// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/Charger.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Charger {

  /// <summary>Holder for reflection information generated from telemetry/Charger.proto</summary>
  public static partial class ChargerReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/Charger.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static ChargerReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Chd0ZWxlbWV0cnkvQ2hhcmdlci5wcm90bxIHY2hhcmdlchofZ29vZ2xlL3By",
            "b3RvYnVmL3RpbWVzdGFtcC5wcm90byKxBQoHQ2hhcmdlchIcCg9zdGF0ZV9v",
            "Zl9jaGFyZ2UYASABKAVIAIgBARIbCg5jdXJyZW50X2ltcG9ydBgCIAEoCUgB",
            "iAEBEhsKDnBvd2VyX2ltcG9ydGVkGAMgASgJSAKIAQESHAoPZW5lcmd5X2lt",
            "cG9ydGVkGAQgASgJSAOIAQESHAoPY3VycmVudF9vZmZlcmVkGAUgASgJSASI",
            "AQESGgoNcG93ZXJfb2ZmZXJlZBgGIAEoCUgFiAEBEhYKCWZyZXF1ZW5jeRgH",
            "IAEoCUgGiAEBEhgKC3RlbXBlcmF0dXJlGAggASgJSAeIAQESFAoHdm9sdGFn",
            "ZRgJIAEoCUgIiAEBEhAKA3JwbRgKIAEoCUgJiAEBEhQKDGNvbm5lY3Rvcl9p",
            "ZBgLIAEoCRIbCg50cmFuc2FjdGlvbl9pZBgMIAEoCUgKiAEBEioKBXBoYXNl",
            "GA0gASgOMhYuY2hhcmdlci5DaGFyZ2VyLlBoYXNlSAuIAQEiegoFUGhhc2US",
            "BgoCTDEQABIGCgJMMhABEgYKAkwzEAISCAoETDFfThADEggKBEwyX04QBBII",
            "CgRMM19OEAUSCAoEUEVfThAGEgUKAU4QBxIJCgVMMV9MMhAIEgkKBUwyX0wz",
            "EAkSCQoFTDNfTDEQChIJCgVUT1RBTBALQhIKEF9zdGF0ZV9vZl9jaGFyZ2VC",
            "EQoPX2N1cnJlbnRfaW1wb3J0QhEKD19wb3dlcl9pbXBvcnRlZEISChBfZW5l",
            "cmd5X2ltcG9ydGVkQhIKEF9jdXJyZW50X29mZmVyZWRCEAoOX3Bvd2VyX29m",
            "ZmVyZWRCDAoKX2ZyZXF1ZW5jeUIOCgxfdGVtcGVyYXR1cmVCCgoIX3ZvbHRh",
            "Z2VCBgoEX3JwbUIRCg9fdHJhbnNhY3Rpb25faWRCCAoGX3BoYXNlQnMKG2Nv",
            "bS5jb2RpYmx5Lm1vZGVsLnRlbGVtZXRyeUIMQ2hhcmdlclByb3RvygIbRG9t",
            "YWluTW9kZWxcUHJvdG9cVGVsZW1ldHJ54gInRG9tYWluTW9kZWxcUHJvdG9c",
            "VGVsZW1ldHJ5XEdQQk1ldGFkYXRhYgZwcm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Charger.Charger), global::Charger.Charger.Parser, new[]{ "StateOfCharge", "CurrentImport", "PowerImported", "EnergyImported", "CurrentOffered", "PowerOffered", "Frequency", "Temperature", "Voltage", "Rpm", "ConnectorId", "TransactionId", "Phase" }, new[]{ "StateOfCharge", "CurrentImport", "PowerImported", "EnergyImported", "CurrentOffered", "PowerOffered", "Frequency", "Temperature", "Voltage", "Rpm", "TransactionId", "Phase" }, new[]{ typeof(global::Charger.Charger.Types.Phase) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Charger : pb::IMessage<Charger>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Charger> _parser = new pb::MessageParser<Charger>(() => new Charger());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<Charger> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Charger.ChargerReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Charger() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Charger(Charger other) : this() {
      _hasBits0 = other._hasBits0;
      stateOfCharge_ = other.stateOfCharge_;
      currentImport_ = other.currentImport_;
      powerImported_ = other.powerImported_;
      energyImported_ = other.energyImported_;
      currentOffered_ = other.currentOffered_;
      powerOffered_ = other.powerOffered_;
      frequency_ = other.frequency_;
      temperature_ = other.temperature_;
      voltage_ = other.voltage_;
      rpm_ = other.rpm_;
      connectorId_ = other.connectorId_;
      transactionId_ = other.transactionId_;
      phase_ = other.phase_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Charger Clone() {
      return new Charger(this);
    }

    /// <summary>Field number for the "state_of_charge" field.</summary>
    public const int StateOfChargeFieldNumber = 1;
    private int stateOfCharge_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int StateOfCharge {
      get { if ((_hasBits0 & 1) != 0) { return stateOfCharge_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        stateOfCharge_ = value;
      }
    }
    /// <summary>Gets whether the "state_of_charge" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasStateOfCharge {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "state_of_charge" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearStateOfCharge() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "current_import" field.</summary>
    public const int CurrentImportFieldNumber = 2;
    private string currentImport_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string CurrentImport {
      get { return currentImport_ ?? ""; }
      set {
        currentImport_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "current_import" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCurrentImport {
      get { return currentImport_ != null; }
    }
    /// <summary>Clears the value of the "current_import" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCurrentImport() {
      currentImport_ = null;
    }

    /// <summary>Field number for the "power_imported" field.</summary>
    public const int PowerImportedFieldNumber = 3;
    private string powerImported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string PowerImported {
      get { return powerImported_ ?? ""; }
      set {
        powerImported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "power_imported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPowerImported {
      get { return powerImported_ != null; }
    }
    /// <summary>Clears the value of the "power_imported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPowerImported() {
      powerImported_ = null;
    }

    /// <summary>Field number for the "energy_imported" field.</summary>
    public const int EnergyImportedFieldNumber = 4;
    private string energyImported_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string EnergyImported {
      get { return energyImported_ ?? ""; }
      set {
        energyImported_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "energy_imported" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasEnergyImported {
      get { return energyImported_ != null; }
    }
    /// <summary>Clears the value of the "energy_imported" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearEnergyImported() {
      energyImported_ = null;
    }

    /// <summary>Field number for the "current_offered" field.</summary>
    public const int CurrentOfferedFieldNumber = 5;
    private string currentOffered_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string CurrentOffered {
      get { return currentOffered_ ?? ""; }
      set {
        currentOffered_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "current_offered" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCurrentOffered {
      get { return currentOffered_ != null; }
    }
    /// <summary>Clears the value of the "current_offered" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCurrentOffered() {
      currentOffered_ = null;
    }

    /// <summary>Field number for the "power_offered" field.</summary>
    public const int PowerOfferedFieldNumber = 6;
    private string powerOffered_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string PowerOffered {
      get { return powerOffered_ ?? ""; }
      set {
        powerOffered_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "power_offered" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPowerOffered {
      get { return powerOffered_ != null; }
    }
    /// <summary>Clears the value of the "power_offered" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPowerOffered() {
      powerOffered_ = null;
    }

    /// <summary>Field number for the "frequency" field.</summary>
    public const int FrequencyFieldNumber = 7;
    private string frequency_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Frequency {
      get { return frequency_ ?? ""; }
      set {
        frequency_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "frequency" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasFrequency {
      get { return frequency_ != null; }
    }
    /// <summary>Clears the value of the "frequency" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearFrequency() {
      frequency_ = null;
    }

    /// <summary>Field number for the "temperature" field.</summary>
    public const int TemperatureFieldNumber = 8;
    private string temperature_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Temperature {
      get { return temperature_ ?? ""; }
      set {
        temperature_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "temperature" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTemperature {
      get { return temperature_ != null; }
    }
    /// <summary>Clears the value of the "temperature" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTemperature() {
      temperature_ = null;
    }

    /// <summary>Field number for the "voltage" field.</summary>
    public const int VoltageFieldNumber = 9;
    private string voltage_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Voltage {
      get { return voltage_ ?? ""; }
      set {
        voltage_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "voltage" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasVoltage {
      get { return voltage_ != null; }
    }
    /// <summary>Clears the value of the "voltage" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearVoltage() {
      voltage_ = null;
    }

    /// <summary>Field number for the "rpm" field.</summary>
    public const int RpmFieldNumber = 10;
    private string rpm_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Rpm {
      get { return rpm_ ?? ""; }
      set {
        rpm_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "rpm" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasRpm {
      get { return rpm_ != null; }
    }
    /// <summary>Clears the value of the "rpm" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearRpm() {
      rpm_ = null;
    }

    /// <summary>Field number for the "connector_id" field.</summary>
    public const int ConnectorIdFieldNumber = 11;
    private string connectorId_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ConnectorId {
      get { return connectorId_; }
      set {
        connectorId_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "transaction_id" field.</summary>
    public const int TransactionIdFieldNumber = 12;
    private string transactionId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TransactionId {
      get { return transactionId_ ?? ""; }
      set {
        transactionId_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "transaction_id" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTransactionId {
      get { return transactionId_ != null; }
    }
    /// <summary>Clears the value of the "transaction_id" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTransactionId() {
      transactionId_ = null;
    }

    /// <summary>Field number for the "phase" field.</summary>
    public const int PhaseFieldNumber = 13;
    private global::Charger.Charger.Types.Phase phase_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Charger.Charger.Types.Phase Phase {
      get { if ((_hasBits0 & 2) != 0) { return phase_; } else { return global::Charger.Charger.Types.Phase.L1; } }
      set {
        _hasBits0 |= 2;
        phase_ = value;
      }
    }
    /// <summary>Gets whether the "phase" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPhase {
      get { return (_hasBits0 & 2) != 0; }
    }
    /// <summary>Clears the value of the "phase" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPhase() {
      _hasBits0 &= ~2;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as Charger);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(Charger other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (StateOfCharge != other.StateOfCharge) return false;
      if (CurrentImport != other.CurrentImport) return false;
      if (PowerImported != other.PowerImported) return false;
      if (EnergyImported != other.EnergyImported) return false;
      if (CurrentOffered != other.CurrentOffered) return false;
      if (PowerOffered != other.PowerOffered) return false;
      if (Frequency != other.Frequency) return false;
      if (Temperature != other.Temperature) return false;
      if (Voltage != other.Voltage) return false;
      if (Rpm != other.Rpm) return false;
      if (ConnectorId != other.ConnectorId) return false;
      if (TransactionId != other.TransactionId) return false;
      if (Phase != other.Phase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasStateOfCharge) hash ^= StateOfCharge.GetHashCode();
      if (HasCurrentImport) hash ^= CurrentImport.GetHashCode();
      if (HasPowerImported) hash ^= PowerImported.GetHashCode();
      if (HasEnergyImported) hash ^= EnergyImported.GetHashCode();
      if (HasCurrentOffered) hash ^= CurrentOffered.GetHashCode();
      if (HasPowerOffered) hash ^= PowerOffered.GetHashCode();
      if (HasFrequency) hash ^= Frequency.GetHashCode();
      if (HasTemperature) hash ^= Temperature.GetHashCode();
      if (HasVoltage) hash ^= Voltage.GetHashCode();
      if (HasRpm) hash ^= Rpm.GetHashCode();
      if (ConnectorId.Length != 0) hash ^= ConnectorId.GetHashCode();
      if (HasTransactionId) hash ^= TransactionId.GetHashCode();
      if (HasPhase) hash ^= Phase.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasStateOfCharge) {
        output.WriteRawTag(8);
        output.WriteInt32(StateOfCharge);
      }
      if (HasCurrentImport) {
        output.WriteRawTag(18);
        output.WriteString(CurrentImport);
      }
      if (HasPowerImported) {
        output.WriteRawTag(26);
        output.WriteString(PowerImported);
      }
      if (HasEnergyImported) {
        output.WriteRawTag(34);
        output.WriteString(EnergyImported);
      }
      if (HasCurrentOffered) {
        output.WriteRawTag(42);
        output.WriteString(CurrentOffered);
      }
      if (HasPowerOffered) {
        output.WriteRawTag(50);
        output.WriteString(PowerOffered);
      }
      if (HasFrequency) {
        output.WriteRawTag(58);
        output.WriteString(Frequency);
      }
      if (HasTemperature) {
        output.WriteRawTag(66);
        output.WriteString(Temperature);
      }
      if (HasVoltage) {
        output.WriteRawTag(74);
        output.WriteString(Voltage);
      }
      if (HasRpm) {
        output.WriteRawTag(82);
        output.WriteString(Rpm);
      }
      if (ConnectorId.Length != 0) {
        output.WriteRawTag(90);
        output.WriteString(ConnectorId);
      }
      if (HasTransactionId) {
        output.WriteRawTag(98);
        output.WriteString(TransactionId);
      }
      if (HasPhase) {
        output.WriteRawTag(104);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasStateOfCharge) {
        output.WriteRawTag(8);
        output.WriteInt32(StateOfCharge);
      }
      if (HasCurrentImport) {
        output.WriteRawTag(18);
        output.WriteString(CurrentImport);
      }
      if (HasPowerImported) {
        output.WriteRawTag(26);
        output.WriteString(PowerImported);
      }
      if (HasEnergyImported) {
        output.WriteRawTag(34);
        output.WriteString(EnergyImported);
      }
      if (HasCurrentOffered) {
        output.WriteRawTag(42);
        output.WriteString(CurrentOffered);
      }
      if (HasPowerOffered) {
        output.WriteRawTag(50);
        output.WriteString(PowerOffered);
      }
      if (HasFrequency) {
        output.WriteRawTag(58);
        output.WriteString(Frequency);
      }
      if (HasTemperature) {
        output.WriteRawTag(66);
        output.WriteString(Temperature);
      }
      if (HasVoltage) {
        output.WriteRawTag(74);
        output.WriteString(Voltage);
      }
      if (HasRpm) {
        output.WriteRawTag(82);
        output.WriteString(Rpm);
      }
      if (ConnectorId.Length != 0) {
        output.WriteRawTag(90);
        output.WriteString(ConnectorId);
      }
      if (HasTransactionId) {
        output.WriteRawTag(98);
        output.WriteString(TransactionId);
      }
      if (HasPhase) {
        output.WriteRawTag(104);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasStateOfCharge) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(StateOfCharge);
      }
      if (HasCurrentImport) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(CurrentImport);
      }
      if (HasPowerImported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(PowerImported);
      }
      if (HasEnergyImported) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(EnergyImported);
      }
      if (HasCurrentOffered) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(CurrentOffered);
      }
      if (HasPowerOffered) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(PowerOffered);
      }
      if (HasFrequency) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Frequency);
      }
      if (HasTemperature) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Temperature);
      }
      if (HasVoltage) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Voltage);
      }
      if (HasRpm) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Rpm);
      }
      if (ConnectorId.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ConnectorId);
      }
      if (HasTransactionId) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TransactionId);
      }
      if (HasPhase) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) Phase);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(Charger other) {
      if (other == null) {
        return;
      }
      if (other.HasStateOfCharge) {
        StateOfCharge = other.StateOfCharge;
      }
      if (other.HasCurrentImport) {
        CurrentImport = other.CurrentImport;
      }
      if (other.HasPowerImported) {
        PowerImported = other.PowerImported;
      }
      if (other.HasEnergyImported) {
        EnergyImported = other.EnergyImported;
      }
      if (other.HasCurrentOffered) {
        CurrentOffered = other.CurrentOffered;
      }
      if (other.HasPowerOffered) {
        PowerOffered = other.PowerOffered;
      }
      if (other.HasFrequency) {
        Frequency = other.Frequency;
      }
      if (other.HasTemperature) {
        Temperature = other.Temperature;
      }
      if (other.HasVoltage) {
        Voltage = other.Voltage;
      }
      if (other.HasRpm) {
        Rpm = other.Rpm;
      }
      if (other.ConnectorId.Length != 0) {
        ConnectorId = other.ConnectorId;
      }
      if (other.HasTransactionId) {
        TransactionId = other.TransactionId;
      }
      if (other.HasPhase) {
        Phase = other.Phase;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            StateOfCharge = input.ReadInt32();
            break;
          }
          case 18: {
            CurrentImport = input.ReadString();
            break;
          }
          case 26: {
            PowerImported = input.ReadString();
            break;
          }
          case 34: {
            EnergyImported = input.ReadString();
            break;
          }
          case 42: {
            CurrentOffered = input.ReadString();
            break;
          }
          case 50: {
            PowerOffered = input.ReadString();
            break;
          }
          case 58: {
            Frequency = input.ReadString();
            break;
          }
          case 66: {
            Temperature = input.ReadString();
            break;
          }
          case 74: {
            Voltage = input.ReadString();
            break;
          }
          case 82: {
            Rpm = input.ReadString();
            break;
          }
          case 90: {
            ConnectorId = input.ReadString();
            break;
          }
          case 98: {
            TransactionId = input.ReadString();
            break;
          }
          case 104: {
            Phase = (global::Charger.Charger.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            StateOfCharge = input.ReadInt32();
            break;
          }
          case 18: {
            CurrentImport = input.ReadString();
            break;
          }
          case 26: {
            PowerImported = input.ReadString();
            break;
          }
          case 34: {
            EnergyImported = input.ReadString();
            break;
          }
          case 42: {
            CurrentOffered = input.ReadString();
            break;
          }
          case 50: {
            PowerOffered = input.ReadString();
            break;
          }
          case 58: {
            Frequency = input.ReadString();
            break;
          }
          case 66: {
            Temperature = input.ReadString();
            break;
          }
          case 74: {
            Voltage = input.ReadString();
            break;
          }
          case 82: {
            Rpm = input.ReadString();
            break;
          }
          case 90: {
            ConnectorId = input.ReadString();
            break;
          }
          case 98: {
            TransactionId = input.ReadString();
            break;
          }
          case 104: {
            Phase = (global::Charger.Charger.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the Charger message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum Phase {
        [pbr::OriginalName("L1")] L1 = 0,
        [pbr::OriginalName("L2")] L2 = 1,
        [pbr::OriginalName("L3")] L3 = 2,
        [pbr::OriginalName("L1_N")] L1N = 3,
        [pbr::OriginalName("L2_N")] L2N = 4,
        [pbr::OriginalName("L3_N")] L3N = 5,
        [pbr::OriginalName("PE_N")] PeN = 6,
        [pbr::OriginalName("N")] N = 7,
        [pbr::OriginalName("L1_L2")] L1L2 = 8,
        [pbr::OriginalName("L2_L3")] L2L3 = 9,
        [pbr::OriginalName("L3_L1")] L3L1 = 10,
        [pbr::OriginalName("TOTAL")] Total = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
